#include <stdio.h>
#include <stdlib.h>

//int dx[4] = {0, 0, 1, -1};
//int dy[4] = {1, -1, 0, 0};

class stack {
public:
    int x, y;
    stack *next;
    stack(int a, int b, stack *c): x(a), y(b), next(c) {}
} *one = NULL, *two = NULL, *three = NULL; 

int is;
char *wall[1000];
int *z[1000];

void add1(int x, int y) {
    one = new stack(x, y, one);
    return;
}

void add3(int x, int y) {
    three = new stack(x, y, three);
    return;
}

int get(int &x, int &y) {
    stack *tmp;
    if (two) {
	x = two->x;
	y = two->y;
	tmp = two->next;
	delete two;
	two = tmp;
	return 0;
    } else
	return -1;
}

int get3(int &x, int &y) {
    stack *tmp;
    if (three) {
	x = three->x;
	y = three->y;
	tmp = three->next;
	delete three;
	three = tmp;
	return 0;
    } else
	return -1;
}

void del(void) {
    stack *tmp, *tmp2;
    for (tmp = three; tmp;) {
	tmp2 = tmp->next;
	delete tmp;
	tmp = tmp2;
    }
    three = tmp;
}

void add(int x, int y, int c) {
    if (!is) {
	del();
	is = 1;
    }
    add1(x, y);
    z[x][y] = c + 1;
}

int main(void) {
    int n, c, r;
    int t, tt, i, ii, a, max;
    scanf("%d", &n);
    for (t = 0; t < 1000; t++) {
	wall[t] = NULL;
	z[t] = NULL;
    } 
    for (;n > 0; n--) {
	scanf("%d %d", &c, &r);
	for (t = 0; t < r; t++) {
	    if (!wall[t]) wall[t] = new char[1100];
	    if (!z[t]) z[t] = new int[1100];
	    scanf("%s", wall[t]);
	}
	is = 0;
	for (t = 0; t < r; t++)
	for (tt = 0; tt < c; tt++) 
	if (!is && wall[t][tt] == '.') {
	    a = 0;
	    if (t  > 0     && wall[t - 1][tt] == '.') a++;
	    if (tt > 0     && wall[t][tt - 1] == '.') a++;
	    if (t  < r - 1 && wall[t + 1][tt] == '.') a++;
	    if (tt < c - 1 && wall[t][tt + 1] == '.') a++;
	    if (a < 2) {
		z[t][tt] = 0;
		add(t, tt, -1);
		is = 1;
	    } else
		z[t][tt] = -1;
	} else z[t][tt] = -1;
	is = 1;
	while (is) {
	    two = one;
	    one = NULL;
	    is = 0;
	    while (get(t, tt) != -1) {
		if (!is) add3(t, tt);
		if (t > 0 && wall[t - 1][tt] == '.' && z[t - 1][tt] == -1)
		    add(t - 1, tt, z[t][tt]);
		if (tt > 0 && wall[t][tt - 1] == '.' && z[t][tt - 1] == -1)
		    add(t, tt - 1, z[t][tt]);
		if (t < r - 1 && wall[t + 1][tt] == '.' && z[t + 1][tt] == -1)
		    add(t + 1, tt, z[t][tt]);
		if (tt < c - 1 && wall[t][tt + 1] == '.' && z[t][tt + 1] == -1)
		    add(t, tt + 1, z[t][tt]);
	    }
	}
	max = 0;
//	for (t = 0; t < r; t++) {
//	for (tt = 0; tt < c; tt++)
//	    printf("%d ", z[t][tt]);
//	printf("\n");
//	}
	two = NULL;
	one = NULL;
	get3(i, ii);
	del();
	for (t = 0; t < r; t++)
	for (tt = 0; tt < c; tt++)
	    if 	(t == tt && i == ii) z[t][tt] = 0; else z[t][tt] = -1;
	add(i, ii, -1);
	is = 1;
	while (is) {
	    two = one;
	    one = NULL;
	    is = 0;
	    while (get(t, tt) != -1) {
		if (!is) add3(t, tt);
		if (t > 0 && wall[t - 1][tt] == '.' && z[t - 1][tt] == -1)
		    add(t - 1, tt, z[t][tt]);
		if (tt > 0 && wall[t][tt - 1] == '.' && z[t][tt - 1] == -1)
		    add(t, tt - 1, z[t][tt]);
		if (t < r - 1 && wall[t + 1][tt] == '.' && z[t + 1][tt] == -1)
		    add(t + 1, tt, z[t][tt]);
		if (tt < c - 1 && wall[t][tt + 1] == '.' && z[t][tt + 1] == -1)
		    add(t, tt + 1, z[t][tt]);
	    }
	}
	max = 0;
//	for (t = 0; t < r; t++) {
//	for (tt = 0; tt < c; tt++)
//	    printf("%d ", z[t][tt]);
//	printf("\n");
//	}
	get3(i, ii);
	printf("Maximum rope length is %d.\n", z[i][ii]);
    }
    return 0;
}