#include <stdio.h>

int G[26][26],in[26],out[26],reached[26];
char s[1100];

void DFS(int v){
    if (reached[v]) return;
    reached[v] = 1;
    for (int i = 0; i < 26; i++)
	if (G[v][i]) DFS(i);
}

int main(){
    int t;
    scanf("%d",&t);
    for (; t > 0; t--){
	int n;
	scanf("%d",&n);
	for (int i = 0; i < 26; i++){
	    for (int j = 0; j < 26; j++) G[i][j] = 0;
	    in[i] = out[i] = reached[i] = 0;
	}
	for (int i = 0; i < n; i++){
	    scanf("%s",s);
	    char f = s[0], l = s[strlen(s)-1];
	    G[f-'a'][l-'a'] = 1;
	    out[f-'a']++;
	    in[l-'a']++;
	}
	int ok = 1;
	int start = -1;
	int end = -1;
	for (int i = 0; i < 26; i++)
	    if (out[i] == in[i]+1){
		if (start == -1) start = i;
		else { ok = 0; break; }
	    }
	    else
	    if (in[i] == out[i]+1){
		if (end == -1) end = i;
		else { ok = 0; break; }
	    }
	    else
	    if (in[i] != out[i]){
		ok = 0;
		break;
	    }
	if (ok){
	    if (start == -1)
		for (int i = 0; i < 26; i++)
		    if (in[i] != 0){ start = i; break; }
	    if (start != -1){
		DFS(start);
		for (int i = 0; i < 26; i++)
		    if (in[i] != 0 || out[i] != 0)
			if (!reached[i]){
			    ok = 0;
			    break;
			}
	    }
	}
	if (ok) printf("Ordering is possible.\n");
	else printf("The door cannot be opened.\n");
    }
    return 0;
}